
-- this file contains the indexes and constraints for the PostgreSQL 
-- 		implementation of Cofax



DROP INDEX idx_mappingCode;
DROP INDEX IX_tblArticleOrder;
DROP INDEX ix_mappingCode;
DROP INDEX idx_AllFields;
DROP INDEX idx_disableApproveItemID;
DROP INDEX idx_itemID;
DROP INDEX idx_itemID0;
DROP INDEX idxUpdateDate;
DROP INDEX docID;
DROP INDEX idx_articleTypeID;
DROP INDEX IX_tblArticleTypes;
DROP INDEX IX_tblArticleTypes_1;
DROP INDEX idx_articleTypeDisable;
DROP INDEX idx_compound ;
DROP INDEX idx_pubName;
DROP INDEX tblrelatedlinks0;
DROP INDEX idx_Sections;
DROP INDEX idx_pubName0;
DROP INDEX idx_mappingCodeSectionName;



DROP VIEW viewActiveArticles;
DROP VIEW viewActiveArticleTypes;
DROP VIEW viewAllArticles;
DROP VIEW viewArticleInfo;
DROP VIEW viewNavigation;
DROP VIEW viewPubicationsAndSections;
DROP VIEW viewTblActiveArticles;
DROP VIEW viewTblActiveArticlesColumnists;
DROP VIEW viewActiveArticlesColumnsitsNoMappings;
DROP VIEW viewActiveArticlesColumnsitsNoM;
DROP VIEW viewActiveArticlesColumnsits;










-- BEGIN TRANSACTION CREATE_VIEWS_INDEXES



















-- create indexes and add constraints below 




CREATE INDEX idx_mappingCode ON tblSections(mappingCode);


ALTER TABLE tblAdsTags
	ALTER PUBNAME SET DEFAULT ('');
ALTER TABLE tblAdsTags	
	ALTER SECTIONNAME SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER ADSPUBLICATION SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER ADSSECTION SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBANNER SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBANNERTOP SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBANNERBOTTOM SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBANNERMIDDLE SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBUTTON SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBUTTONGROUPA SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBUTTONGROUPB SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBUTTONGROUPC SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBUTTONGROUPD SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER SHOWADSBUTTONGROUPE SET DEFAULT ('');
ALTER TABLE tblAdsTags
	ALTER updateDate SET DEFAULT (CURRENT_TIMESTAMP);




ALTER TABLE tblArticleOrder 
	ALTER mappingCode SET DEFAULT (0);
ALTER TABLE tblArticleOrder
	ADD CONSTRAINT PK_tblArticleOrder PRIMARY KEY
	(
		itemID,
		mappingCode
	)   
;




ALTER TABLE tblArticles 
	ALTER memo SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER correction SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER headline SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER lead SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER dateline SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER keywords SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER pubData SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER versionNum SET DEFAULT (0);
ALTER TABLE tblArticles
	ALTER docType SET DEFAULT (0);
ALTER TABLE tblArticles
	ALTER shortHeadline SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER byline SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER data SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER body SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER section SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER disableArticle SET DEFAULT (0);
ALTER TABLE tblArticles
	ALTER headline2 SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER bycredit SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER webLead SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER approved SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER noindex SET DEFAULT (0);
ALTER TABLE tblArticles
	ALTER orgDocID SET DEFAULT (0);
ALTER TABLE tblArticles
	ALTER articleTypeID SET DEFAULT (0);
ALTER TABLE tblArticles
	ALTER webHeadline SET DEFAULT ('');
ALTER TABLE tblArticles
	ALTER leadIn SET DEFAULT ('');
ALTER TABLE tblArticles
	ADD CONSTRAINT PK_tblArticles PRIMARY KEY 
	(
		pubName,
		pubDate,
		versionNum,
		section,
		fileName
	)   
;




ALTER TABLE tblArticleTypeCategories 
	ALTER articleTypeCategory SET DEFAULT ('');
ALTER TABLE tblArticleTypeCategories 
	ADD CONSTRAINT PK_tblArticleTypeCategories PRIMARY KEY
	(
		articleTypeCategoryID
	)   
;




ALTER TABLE tblArticleTypes  
	ALTER pubName SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleType SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeDesc SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeImage SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeByLine SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeTitle SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeCategoryID SET DEFAULT (1);
ALTER TABLE tblArticleTypes 
	ALTER articleTypeCategory SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeleadIn SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeemail SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypebio SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeShirtTail SET DEFAULT ('');
ALTER TABLE tblArticleTypes 
	ALTER articleTypeDisplayOnIndex SET DEFAULT (1);
ALTER TABLE tblArticleTypes 
	ALTER disableArticleType SET DEFAULT (0);
ALTER TABLE tblArticleTypes 
	ADD CONSTRAINT PK_tblArticleTypes PRIMARY KEY
	(
		pubName,
		articleType
	)   
;




ALTER TABLE tblMonthDay 
	ALTER monthNameShort SET DEFAULT ('');
ALTER TABLE tblMonthDay 
	ALTER monthID SET DEFAULT ('');
ALTER TABLE tblMonthDay 
	ALTER dayNameShort SET DEFAULT ('');
ALTER TABLE tblMonthDay 
	ALTER dayName SET DEFAULT ('');
ALTER TABLE tblMonthDay 
	ALTER dayID SET DEFAULT ('');
ALTER TABLE tblMonthDay 
	ALTER numberDayOfMonth SET DEFAULT ('');
ALTER TABLE tblMonthDay 
	ADD CONSTRAINT PK_tblMonthDay PRIMARY KEY
	(
		monthDayID
	)   
;




ALTER TABLE tblMultimedia 
	ALTER caption SET DEFAULT ('');
ALTER TABLE tblMultimedia 
	ALTER mimeType SET DEFAULT ('');
ALTER TABLE tblMultimedia 
	ALTER rank SET DEFAULT (999);
ALTER TABLE tblMultimedia 
	ALTER credit SET DEFAULT ('');
ALTER TABLE tblMultimedia 
	ADD CONSTRAINT PK_tblMultimedia PRIMARY KEY
	(
		type,
		itemID
	)   
;




ALTER TABLE tblPackageTags 
	ALTER returnError SET DEFAULT (0);
ALTER TABLE tblPackageTags 
	ADD CONSTRAINT PK_tblPackageTags PRIMARY KEY
	(
		tag_name
	)   
;




ALTER TABLE tblPublications
	ALTER publication SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER pubDesc SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER tagLine SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER homePage SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER icon SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER iconWidth SET DEFAULT (0);
ALTER TABLE tblPublications
	ALTER iconHeight SET DEFAULT (0);
ALTER TABLE tblPublications
	ALTER javaScript SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER rolloverTime SET DEFAULT (5);
ALTER TABLE tblPublications
	ALTER hostName SET DEFAULT ('');
ALTER TABLE tblPublications
	ALTER defaultSection SET DEFAULT ('home');
ALTER TABLE tblPublications
	ALTER defaultSectionWithDate SET DEFAULT (1);
ALTER TABLE tblPublications
	ADD CONSTRAINT PK_tblPublications PRIMARY KEY
	(
		pubID
	)   
;




ALTER TABLE tblRelatedLinks 
	ADD CONSTRAINT PK_tblRelatedLinks PRIMARY KEY 
	(
		itemID,
		link
	)   
;




ALTER TABLE tblSections 
	ALTER subMapOf SET DEFAULT (0);
ALTER TABLE tblSections 
	ALTER sectionType SET DEFAULT (1);
ALTER TABLE tblSections 
	ALTER rank SET DEFAULT (999);
ALTER TABLE tblSections 
	ALTER url SET DEFAULT ('');
ALTER TABLE tblSections 
	ALTER displayOnIndex SET DEFAULT (1);
ALTER TABLE tblSections 
	ADD CONSTRAINT PK_tblSections PRIMARY KEY
	(
		pubName,
		section
	)   
;




CREATE INDEX IX_tblArticleOrder ON tblArticleOrder(itemID);

CREATE INDEX ix_mappingCode ON tblArticleOrder(mappingCode);

CREATE INDEX idx_AllFields ON tblArticleOrder(mappingCode, itemID, rank);

CREATE INDEX idx_disableApproveItemID ON tblArticles(disableArticle, approved, disableIndex, itemID);

CREATE INDEX idx_itemID ON tblArticles(itemID);

CREATE INDEX idxUpdateDate ON tblArticles(updateDate);

CREATE INDEX docID ON tblArticles(docID);

CREATE INDEX idx_articleTypeID ON tblArticleTypes(articleTypeID);

CREATE INDEX IX_tblArticleTypes ON tblArticleTypes(pubName, articleTypeName);

CREATE INDEX IX_tblArticleTypes_1 ON tblArticleTypes(pubName, articleTypeCategory);

CREATE INDEX idx_articleTypeDisable ON tblArticleTypes(articleTypeID, disableArticleType);

CREATE INDEX idx_itemID0 ON tblMultimedia(itemID);

CREATE INDEX idx_compound ON tblMultimedia(type, itemID, itemName, caption);

CREATE INDEX idx_pubName ON tblPublications(pubName);

CREATE INDEX tblrelatedlinks0 ON tblRelatedLinks(itemID);

CREATE INDEX idx_Sections ON tblSections(pubName, section, sectionName);

CREATE INDEX idx_pubName0 ON tblSections(pubName);

CREATE INDEX idx_mappingCodeSectionName ON tblSections(sectionName, mappingCode, pubName);











/* Create the views */ 
 
CREATE VIEW viewActiveArticles AS 
	SELECT  
		docID,  
		tblArticles.itemID, 
		tblArticles.fileName, 
		versionNum,  
		tblArticles.pubName,  
		tblArticles.pubDate,  
		tblArticles.section,  
		headline,  
		headline2,  
		lead,  
		webLead, 
		dateline,  
		keywords,  
		pubRank,  
		pubData,  
		byline,  
		correction, 
		memo, 
		bycredit,  
		updateDate,  
		docType,  
		body,  
		disableArticle, 
		disableIndex, 
		approved, 
		webHeadline, 
		publication, 
		leadIn, 
		shortTime = convert(char(20),right(updateDate, 7)), 
		dayOfWeek = convert(varchar(15), datename(weekday,  tblArticles.pubDate) ) , 
		pubSectionName = ( SELECT sectionName 
								from tblSections 
								WHERE tblArticles.pubName = tblSections.pubName 
									AND tblArticles.section = tblSections.section ), 
		virtualFolder = tblArticles.pubName +  
            "/" + convert(varchar(4), datepart(year, tblArticles.pubDate) )  +  
 			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
  			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2) + 
            "/" + ( SELECT sectionName 
            			from tblSections 
            			WHERE tblArticles.pubName = tblSections.pubName 
            				AND tblArticles.section = tblSections.section ), 
		pubSectionDesc =  ( SELECT sectionDesc 
								from tblSections 
								WHERE tblArticles.pubName = tblSections.pubName 
									AND tblArticles.section = tblSections.section ), 


	-- Calculated date fields 
		pubYear = convert(varchar(4), datepart(year, tblArticles.pubDate) ) ,  
		pubMonth = right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2), 
		pubDay = right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2), 
		dateFolder = convert(varchar(4), datepart(year, tblArticles.pubDate) )  +  
 			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
  			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2), 
		pubDateLong = convert(varchar(10), datename(dw, tblArticles.pubDate)) + ", " + 
             convert(varchar(11), datename(month, tblArticles.pubDate) ) + " " + 
             convert(varchar(2), datepart(day, tblArticles.pubDate)) + ", " + 
             convert(varchar(4), datepart(year, tblArticles.pubDate)), 
		fullLink = isnull(tblArticles.customURL, tblPublications.hostName + 'content' +  
           	'/' + tblArticles.pubName +  
            '/' + convert(varchar(4), datepart(year, tblArticles.pubDate) )  + 
            '/' + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
            '/' + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2) +  
            '/' + ( SELECT sectionName 
            			from tblSections 
            			WHERE tblArticles.pubName = tblSections.pubName 
            				AND tblArticles.section = tblSections.section ) + 
            '/' + fileName + '.htm'), 


	-- Image data from tblRelatedMultimedia 
		articleLeadIn = articleTypeLeadIn, 
		sigImage = articleTypeImage, 
		sigImageCaption = articleTypeName, 
		articleTypeCategory, 
		articleTypeByline, 
		articleTypeTitle, 
		articleTypeName, 
		articleTypeBio, 
		articleTypeDisplayOnIndex, 
 
		listImage = (SELECT isNull(itemName, '') 
						from  tblMultimedia 
						WHERE  tblArticles.itemID = tblMultimedia.itemID 
							AND tblMultimedia.type='sectionImage'), 
		listImageCaption = (SELECT isNull(caption, '') 
								from  tblMultimedia 
								WHERE  tblArticles.itemID = tblMultimedia.itemID 
									AND tblMultimedia.type='sectionImage'), 
		articleImage = (SELECT isNull(itemName, '') 
							from  tblMultimedia 
							WHERE  tblArticles.itemID = tblMultimedia.itemID 
								AND tblMultimedia.type='articleImage'), 
		articleImageCaption = (SELECT isNull(caption, '') 
								from  tblMultimedia 
								WHERE  tblArticles.itemID = tblMultimedia.itemID 
									AND tblMultimedia.type='articleImage'), 
 
 
	--relatedLinksCount = (select count(link) 
							from tblRelatedLinks d 
							where d.itemID = tblArticles.itemID), 
		relatedLinksCount = 0, 
 
	-- Data from tblSections 
		tblSections.sectionName, 
		tblSections.sectionDesc, 
		tblSections.sigDir, 
		sectionImage = tblSections.image, 
		tblSections.mappingCode, 
		tblSections.sectionType, 
		tblPublications.pubDesc, 
	-- Data from tblArticleOrders 
		orderingRank = tblArticleOrder.rank 
		
FROM tblArticles, tblSections, tblArticleOrder, tblPublications, tblArticleTypes 
WHERE tblArticles.itemID = tblArticleOrder.itemID 
	AND tblArticleOrder.mappingCode = tblSections.mappingCode 
	AND tblArticles.articleTypeID *= tblArticleTypes.articleTypeID 
	AND tblSections.pubName = tblPublications.pubName 
	--AND tblArticles.approved > '' 
	AND tblArticles.disableArticle = 0 
	AND tblArticleTypes.disableArticleType = 0 
;










CREATE VIEW viewActiveArticleTypes AS 
	SELECT tblArticleTypes.pubName,  
	    tblArticleTypes.articleType,  
	    tblArticleTypes.articleTypeName,  
	    tblArticleTypes.articleTypeDesc,  
	    tblArticleTypes.articleTypeMappingCode AS articleTypeMapingCode, 
		tblArticleTypes.articleTypeImage,  
	    tblArticleTypes.articleTypeByline,  
    	tblArticleTypes.articleTypeTitle,  
    	tblArticleTypes.articleTypeCategoryID,  
    	tblArticleTypes.articleTypeCategory,  
    	tblArticleTypes.articleTypeLeadIn as articleTypeLeadIn ,  
    	tblArticleTypes.articleTypeEmail,  
    	tblArticleTypes.articleTypeBio,  
    	tblArticleTypes.articleTypeShirtTail,  
    	tblArticleTypes.articleTypeDisplayOnIndex,  
    	tblSections.section, tblSections.sectionName,  
    	tblSections.sectionDesc as sectionDesc 
FROM tblArticleTypes 
LEFT OUTER JOIN tblSections 
	ON (tblArticleTypes.articleTypeMappingCode = tblSections.mappingCode)
WHERE (tblArticleTypes.articleTypeDisplayOnIndex = 1) 
;












CREATE view viewAllArticles AS 
	SELECT  
		docID,  
		tblArticles.itemID, 
		tblArticles.fileName, 
		versionNum,  
		tblArticles.pubName,  
		tblArticles.pubDate,  
		tblArticles.section,  
		headline,  
		headline2,  
		lead,  
		webLead, 
		dateline,  
		keywords,  
		pubRank,  
		pubData,  
		byline,  
		bycredit,  
		updateDate,  
		docType,  
		body,  
		disableArticle, 
		disableIndex, 
		approved, 
		webHeadline, 
		leadIn, 
		customURL, 
		shortTime = convert(char(20),right(updateDate, 7)), 
		dayOfWeek = convert(varchar(15), datename(weekday,  tblArticles.pubDate) ) , 
 
		virtualFolder = tblArticles.pubName +  
            "/" + convert(varchar(4), datepart(year, tblArticles.pubDate) )  +  
 			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
  			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2) + 
            "/" + ( SELECT sectionName 
            			from tblSections 
            			WHERE tblArticles.pubName = tblSections.pubName 
            				AND tblArticles.section = tblSections.section ), 
 
		--listImageID = (SELECT DISTINCT max(isNull(multimediaID, '')) from  tblMultimedia 
			--WHERE  tblArticles.itemID = tblMultimedia.itemID 
				--AND tblMultimedia.type='sectionImage'), 
		--articleImageID = (SELECT DISTINCT max(isNull(multimediaID, '')) from  tblMultimedia 
			--WHERE  tblArticles.itemID = tblMultimedia.itemID 
				--AND tblMultimedia.type='articleImage'), 
 
		--listImage = (SELECT isNull(itemName, '') from  tblMultimedia 
			--WHERE  tblArticles.itemID = tblMultimedia.itemID 
				--AND tblMultimedia.type='sectionImage'), 
		--listImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
			--WHERE  tblArticles.itemID = tblMultimedia.itemID 
				--AND tblMultimedia.type='sectionImage'), 
		--articleImage = (SELECT isNull(itemName, '') from  tblMultimedia 
			--WHERE  tblArticles.itemID = tblMultimedia.itemID 
				--AND tblMultimedia.type='articleImage'), 
		--articleImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
			--WHERE  tblArticles.itemID = tblMultimedia.itemID 
				--AND tblMultimedia.type='articleImage'), 
 
 
	-- Calculated date fields 
		pubYear = convert(varchar(4), datepart(year, tblArticles.pubDate) ) ,  
		pubMonth = right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2), 
		pubDay = right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2), 
		dateFolder = convert(varchar(4), datepart(year, tblArticles.pubDate) )  +  
 			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
  			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2), 
		pubDateLong = convert(varchar(10), datename(dw, tblArticles.pubDate)) + ", " + 
             convert(varchar(4), datename(month, tblArticles.pubDate) ) + " " + 
             convert(varchar(2), datepart(day, tblArticles.pubDate)) + ", " + 
             convert(varchar(4), datepart(year, tblArticles.pubDate)), 


	-- Date from tblArticleTypes 
		tblArticleTypes.articleType, 
		tblArticleTypes.articleTypeID, 


	-- Data from tblSections 
		tblSections.sectionName, 
		tblSections.sectionDesc, 
		tblSections.sigDir, 
		sectionImage = tblSections.image, 
		tblSections.mappingCode, 
		tblSections.sectionType, 
	
	
	-- Data from tblArticleOrders 
		orderingRank = tblArticleOrder.rank 
FROM tblArticles, tblSections, tblArticleOrder, tblArticleTypes 
WHERE tblArticles.itemID = tblArticleOrder.itemID 
	AND tblArticleOrder.mappingCode = tblSections.mappingCode 
	AND tblArticles.articleTypeID *= tblArticleTypes.articleTypeID 
;












CREATE view viewArticleInfo AS 
	SELECT  
		tblArticles.docID, 
		tblArticles.itemID, 
		tblArticles.fileName, 
		versionNum,  
		tblArticles.pubName,  
		tblArticles.pubDate,  
		tblArticles.section,  
 
		listImageID = (SELECT isNull(multimediaID, '') from  tblMultimedia 
			WHERE  tblArticles.itemID = tblMultimedia.itemID 
				AND tblMultimedia.type='sectionImage'), 
		articleImageID = (SELECT isNull(multimediaID, '') from  tblMultimedia 
			WHERE  tblArticles.itemID = tblMultimedia.itemID 
				AND tblMultimedia.type='articleImage'), 
		listImage = (SELECT isNull(itemName, '') from  tblMultimedia 
			WHERE  tblArticles.itemID = tblMultimedia.itemID 
				AND tblMultimedia.type='sectionImage'), 
		listImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
			WHERE  tblArticles.itemID = tblMultimedia.itemID 
				AND tblMultimedia.type='sectionImage'), 
		articleImage = (SELECT isNull(itemName, '') from  tblMultimedia 
			WHERE  tblArticles.itemID = tblMultimedia.itemID 
				AND tblMultimedia.type='articleImage'), 
		articleImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
			WHERE  tblArticles.itemID = tblMultimedia.itemID 
				AND tblMultimedia.type='articleImage'), 
	-- Calculated date fields 
		pubYear = convert(varchar(4), datepart(year, tblArticles.pubDate) ) ,  
		pubMonth = right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2), 
		pubDay = right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2), 
		dateFolder = convert(varchar(4), datepart(year, tblArticles.pubDate) )  +  
 			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
  			"/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2) 
FROM tblArticles 
;











CREATE VIEW viewNavigation AS 
	SELECT  
		navigationLink = case 
			when url <> '' then url 
				else '../' +  tblSections.sectionName + '/' 
			end, 
		tblSections.pubName, 
 		tblSections.section, 
        tblSections.sectionName, 
 		tblSections.sectionDesc, 
		tblSections.rank, 
 		sectionImage = tblSections.image, 
 		tblSections.sigDir, 
		include = tblSections.include, 
		promo = tblSections.promo, 
		tblPublications.pubDesc 
FROM tblSections, tblPublications 
WHERE tblSections.pubName = tblPublications.pubName 
	AND tblSections.displayOnIndex = 1 
;














CREATE VIEW viewPublicationsAndSections AS 
	SELECT  
		tblSections.pubName, 
 		tblSections.section, 
        tblSections.sectionName, 
 		tblSections.sectionDesc, 
 		sectionImage = tblSections.image, 
 		tblSections.sigDir, 
		--        publicationJavaSecript = tblPublications.javaScript, 
		--        sectionJavaSecript = tblSections.javaScript 
		include = tblSections.include, 
		promo = tblSections.promo, 
		tblSections.mappingCode, 
		tblSections.subMapOf ,
		tblSections.rank,
		tblSections.displayOnIndex,
		tblSections.url
FROM tblSections, tblPublications 
WHERE tblSections.pubName = tblPublications.pubName 
;






CREATE view viewTblActiveArticles AS
	SELECT 
		docID, 
		o.itemID,
		fileName,
		versionNum, 
		o.pubName, 
		o.pubDate, 
		sa.section, 
		headline, 
		headline2, 
		lead, 
		webLead,
		dateline, 
		keywords, 
		pubRank, 
		pubData, 
		byline, 
		correction,
		memo,
		bycredit, 
		updateDate, 
		docType, 
		body, 
		disableArticle,
		disableIndex,
		approved,
		webHeadline,
		publication,
		leadIn,
		shortTime ,
		dayOfWeek ,
		pubSectionName = sa.sectionName,
		virtualFolder ,
		pubSectionDesc ,


	-- Calculated date fields
		pubYear , 
		pubMonth ,
		pubDay ,
		dateFolder ,
		pubDateLong ,
		fullLink ,


	-- Image data from tblRelatedMultimedia
		articleLeadIn ,
		sigImage ,
		sigImageCaption ,
		articleTypeCategory,
		articleTypeByline,
		articleTypeTitle,
		articleTypeName,
		articleTypeBio,
		articleTypeDisplayOnIndex,
		listImage,
		listImageCaption,
		articleImage ,
		articleImageCaption ,


		--relatedLinksCount = (select count(link) 
								from tblRelatedLinks d 
								where d.itemID = tblArticles.itemID),
		relatedLinksCount = 0,

		so.sectionName ,
		pl.sectionDesc,
		pl.sigDir,
		sectionImage,
		o.mappingCode,
		pl.sectionType,
		pl.pubDesc,
		pl.hostName,


	-- Data from tblArticleOrder
		orderingRank = o.rank
FROM tblArticleOrder AS o 
INNER JOIN tblArticles AS a 
	on (o.itemID = a.itemID)
INNER JOIN tblArticlePreload AS pl 
	on ((o.itemID = pl.itemID) and (o.mappingcode = pl.mappingcode))
INNER JOIN tblPublications AS pb 
	on (o.pubName = pb.pubName)
LEFT OUTER JOIN tblSections AS so 
	on (so.mappingcode = o.mappingcode)
LEFT OUTER JOIN tblSections AS sa 
	on ((sa.section = a.section) and (sa.pubname = a.pubname))
LEFT OUTER JOIN tblArticleTypes AS t 
	on (a.articletypeid = t.articletypeid)
;










CREATE VIEW viewTblActiveArticlesColumnists AS
	SELECT 
		docID,
		tblArticles.itemID,
		tblArticles.fileName,
		versionNum,
		tblArticles.pubName, 
		tblArticles.pubDate,
		tblArticles.section,
		headline,
		headline2,
		lead,
		webLead,
		dateline, 
		keywords,
		pubRank,
		pubData,
		byline,
		correction,
		memo,
		bycredit,
		updateDate,
		docType,
		body,
		disableArticle,
		disableIndex,
		approved,
		webHeadline,
		tblPublications.publication,
		leadIn,
		tblArticlePreload.shortTime,
		tblArticlePreload.dayOfWeek,
		tblArticlePreload.virtualFolder,
		tblArticlePreload.pubSectionDesc,
		tblArticlePreload.pubYear,
		tblArticlePreload.pubMonth,
		tblArticlePreload.pubDay,
		tblArticlePreload.dateFolder,
		tblArticlePreload.pubDateLong,
		tblArticlePreload.fullLink,
		articleLeadIn = articleTypeLeadIn,
		sigImage = articleTypeImage,
		sigImageCaption = articleTypeName,
		articleTypeCategory, articleTypeByline,
		articleTypeTitle,
		articleTypeName,
		articleTypeBio,
		articleTypeDisplayOnIndex,
		tblArticles.articleTypeID,
		tblArticlePreload.listImage,
		tblArticlePreload.listImageCaption,
		tblArticlePreload.articleImage,
		tblArticlePreload.articleImageCaption,
		relatedLinksCount = 0,
		tblSections.sectionName,
		tblSections.sectionDesc,
		tblSections.sigDir,
		sectionImage = tblSections.image,
		tblSections.mappingCode,
		tblSections.sectionType,
		tblPublications.pubDesc,
		orderingRank = tblArticleOrder.rank
FROM tblArticles, 
	tblArticlePreload, 
	tblSections, 
	tblArticleOrder,
	tblArticleTypes, 
	tblPublications
WHERE tblArticles.itemID = tblArticleOrder.itemID
	AND tblArticles.itemID = tblArticlePreload.itemID
	AND tblArticleOrder.mappingCode = tblArticlePreload.mappingCode
	AND tblArticleOrder.mappingCode = tblSections.mappingCode
	AND tblSections.pubName = tblPublications.pubName
	AND tblArticles.articleTypeID = tblArticleTypes.articleTypeID
	AND disableArticle = 0
;







CREATE VIEW viewTblActiveArticlesColumnistsNoMappings AS
	SELECT 
		docID,
		tblArticles.itemID,
		tblArticles.fileName,
		versionNum,
		tblArticles.pubName, 
		tblArticles.pubDate,
		tblArticles.section,
		headline,
		headline2,
		lead,
		webLead,
		dateline, 
		keywords,
		pubRank,
		pubData,
		byline,
		correction,
		memo,
		bycredit,
		updateDate,
		docType,
		body,
		disableArticle,
		disableIndex,
		approved,
		webHeadline,
		tblPublications.publication,
		leadIn,
		tblArticlePreload.shortTime,
		tblArticlePreload.dayOfWeek,
		tblArticlePreload.virtualFolder,
		tblArticlePreload.pubSectionDesc,
		tblArticlePreload.pubYear,
		tblArticlePreload.pubMonth,
		tblArticlePreload.pubDay,
		tblArticlePreload.dateFolder,
		tblArticlePreload.pubDateLong,
		tblArticlePreload.fullLink,
		articleLeadIn = articleTypeLeadIn,
		sigImage = articleTypeImage,
		sigImageCaption = articleTypeName,
		articleTypeCategory,
		articleTypeByline,
		articleTypeTitle,
		articleTypeName,
		articleTypeBio,
		articleTypeDisplayOnIndex,
		tblArticles.articleTypeID,
		tblArticlePreload.listImage,
		tblArticlePreload.listImageCaption,
		tblArticlePreload.articleImage,
		tblArticlePreload.articleImageCaption,
		relatedLinksCount = 0,
		tblPublications.pubDesc
FROM tblArticles, 
	tblArticlePreload, 
	tblSections, 
	tblArticleTypes, 
	tblPublications
WHERE tblArticles.pubName = tblSections.pubName
	AND tblArticles.itemID = tblArticlePreload.itemID
	AND tblSections.mappingCode = tblArticlePreload.mappingCode
	AND tblArticles.section = tblSections.section
	AND tblSections.pubName = tblPublications.pubName
	AND tblArticles.articleTypeID = tblArticleTypes.articleTypeID
	AND tblArticles.disableArticle = 0
;


--COMMIT TRANSACTION CREATE_VIEWS_INDEXES
