















CREATE PROCEDURE cf_getActiveColumnists
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
SELECT*
from viewActiveArticleTypes
where pubName = @pubName
AND articleTypeCategory  = @sectionName
order by sectionDesc
GO
















CREATE procedure cf_getAdsTags
@pubName varchar(50),
@sectionName varchar(50)
AS
SELECT *
from tblAdsTags
where pubName = @pubName
AND sectionName = @sectionName
GO

















CREATE PROC cf_getAllPublications
AS
BEGIN
 SELECT publication, pubName, pubDesc, tagLine, homePage,
             icon, iconWidth,  iconHeight, javaScript,
 pubID, rolloverTime, hostName, defaultSection, 
 defaultSectionWithDate
 FROM tblPublications
 ORDER BY publication
END
GO














CREATE PROCEDURE cf_getAllSections
@pubName varchar(50)
AS
select *, image=sectionImage 
from viewPublicationsAndSections
where pubName = @pubName
order by sectionDesc asc
GO















CREATE PROC cf_getAllSectionsByType
@pubName varchar(50),
@sectionType int
AS
BEGIN
 SELECT * 
        FROM tblSections 
        WHERE pubName = @pubName 
        AND sectionType = @sectionType 
        ORDER BY sectionDesc 
END
GO













CREATE procedure cf_getArticle
@pubName varchar(50),
@pubDate timestamp,
@sectionName varchar(50),
@fileName varchar(50)
AS
SELECT *,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND fileName = @fileName
GO

















CREATE procedure cf_getArticlefromid
@itemID varchar(20)
AS
SELECT *,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount
from viewTblActiveArticles
where itemID = @itemID
GO

















CREATE procedure cf_getArticlefromidworking
@ID varchar(20)
AS
SELECT tblArticles.*
from tblArticles
WHERE tblArticles.docID = @ID
AND approved > ''
AND disableArticle = 0
GO


















CREATE procedure cf_getArticleLikeFileName
@pubName varchar(50),
@pubDate timestamp,
@sectionName varchar(50),
@fileName varchar(20)
AS
SELECT *,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND fileName like "@fileName%"
GO














CREATE PROCEDURE cf_getArticleType
@articleTypeID varchar(100)
AS
SELECT * from tblArticleTypes
WHERE articleTypeID = @articleTypeID
GO













CREATE PROCEDURE cf_getArticleTypeByID
@articleTypeID int
AS
select *
from tblArticleTypes
where articleTypeID = @articleTypeID
GO














CREATE PROCEDURE cf_getArticleTypeCategories
AS
SELECT distinct articleTypeCategory from tblArticleTypes
GO

















CREATE PROCEDURE cf_getArticleTypes
@pubName varchar(50)
AS
SELECT * from tblArticleTypes
WHERE pubName = @pubName
GO
















CREATE PROCEDURE cf_getColumnistArchive
@pubName varchar(50),
@articleTypeName varchar(50),
@startPubDate varchar(50) = '',
@endPubDate varchar(50) = ''
AS
IF (@startPubDate = '')
BEGIN
     SET @startPubDate = dateadd(yy, -1, getdate())
END
IF (@endPubDate = '')
BEGIN
     SET @endPubDate = getdate()
END
DECLARE @articleTypeID int
SELECT @articleTypeID = articleTypeID 
FROM tblArticleTypes 
WHERE articleTypeName = @articleTypeName
AND pubName = @pubName
SELECT DISTINCT
docID, 
viewTblActiveArticlesColumnists.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
--disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
--articleTypeBio,
articleTypeByline,
articleTypeName,
articleTypeTitle,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
--sectionName,
--sectionDesc,
--sigDir,
--sectionImage ,
--orderingRank,
articleTypeName,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticlesColumnists
where pubName = @pubName
AND pubDate >= @startPubDate
AND pubDate <= @endPubDate
--AND articleTypeName = @articleTypeName
AND articleTypeID in (select articleTypeID from tblArticleTypes where pubName = @pubName and articleTypeName=@articleTypeName)
AND disableIndex = 0
AND sectionType = 1
order by pubDate desc, updateDate desc
GO

















CREATE PROCEDURE cf_getColumnistByDate
@pubName varchar(50),
@articleTypeName varchar(50),
@pubdate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
viewTblActiveArticlesColumnists.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
articleTypeBio,
articleTypeByline,
articleTypeName,
articleTypeTitle,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticlesColumnists
where pubName = @pubName
AND pubDate = @pubDate
AND articleTypeName = @articleTypeName
AND disableIndex = 0
AND sectionType = 1
order by pubDate desc, isnull(orderingRank,  999), updateDate desc
GO

















CREATE PROCEDURE cf_getColumnistGlossary
@pubName varchar(50),
@articleTypeName varchar(50)
AS
select *
from tblArticleTypes
where pubName = @pubName
and  articleTypeName = @articleTypeName
GO














CREATE PROCEDURE cf_getColumnistList
@pubName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT  distinct itemID,
dateFolder,
virtualFolder,
fileName,
headline,
headline2,
sigImageCaption,
shortTime,
itemName = articleImage,
caption = articleImageCaption,
sigImage,
pubName,
articleLeadIn,
articleTypeName,
articleTypeByline
articleTypeTitle,
articleTypeCategory
from viewTblActiveArticlesColumnists
where pubName = @pubName
AND pubDate = @pubDate
AND sectionType = 1
AND articleTypeCategory = 'columnist'
AND articleTypeDisplayOnIndex >= 1
GO













CREATE PROCEDURE cf_getColumnists
@pubName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT  TOP 10 docID,
dateFolder,
virtualFolder,
fileName,
headline,
headline2,
sigImageCaption,
shortTime,
itemName = articleImage,
caption = articleImageCaption,
sigDir,
sigImage,
pubName,
articleLeadIn,
articleTypeName,
articleTypeByline
articleTypeTitle,
articleTypeCategory
from viewTblActiveArticlesColumnists
where pubName = @pubName
AND pubDate = @pubDate
AND sectionType = 1
AND articleTypeCategory = 'columnist'
AND articleTypeDisplayOnIndex >= 1
order by pubMonth desc, pubDay desc
GO














CREATE PROCEDURE cf_getInclude
@pubName varchar(50),
@includeName varchar(50),
@sectionName varchar(50) = '',
@dayOfWeek varchar(50) = ''
AS
SELECT TOP 1 * from tblIncludes
WHERE pubName = @pubName AND
includeName = @includeName AND
(sectionName = @sectionName or sectionName = '' ) AND
(dayOfWeek = @dayOfWeek or dayOfWeek = '' )
ORDER BY
sectionName desc, dayOfWeek desc
GO














create proc cf_getMapCount
@mappingCode int,
@pubDate timestamp
AS
BEGIN
 SELECT count(*) as numArticles 
 FROM tblArticles a, tblArticleOrder o 
 WHERE a.itemID = o.itemID 
 AND o.mappingCode = @mappingCode
 AND a.pubDate = @pubDate
 AND a.approved > ''
END
GO













CREATE PROCEDURE cf_getMapDated
@pubName varchar(50),
@sectionName varchar(50),
@startPubDate varchar(50) = '',
@endPubDate varchar(50) = ''
AS
IF (@startPubDate = '')
BEGIN
     SET @startPubDate = '1990-01-01'
END
IF (@endPubDate = '')
BEGIN
     SET @endPubDate = getdate()
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn
from viewTblActiveArticles
where pubName = @pubName
AND pubDate >= @startPubDate
AND pubDate <= @endPubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by pubDate desc, isnull(orderingRank,  999), updateDate desc
GO















CREATE PROCEDURE cf_getMapDatedWithBody
@pubName varchar(50),
@sectionName varchar(50),
@startPubDate varchar(50) = '',
@endPubDate varchar(50) = ''
AS
IF (@startPubDate = '')
BEGIN
     SET @startPubDate = '1990-01-01'
END
IF (@endPubDate = '')
BEGIN
     SET @endPubDate = getdate()
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn,
body
from viewTblActiveArticles
where pubName = @pubName
AND pubDate >= @startPubDate
AND pubDate <= @endPubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by pubDate desc, isnull(orderingRank,  999), updateDate desc
GO
















create proc cf_getMapItemIDs
@mappingCode int,
@pubDate timestamp
AS
BEGIN
 SELECT DISTINCT o.itemID 
 FROM tblArticleOrder o, tblArticles a 
 WHERE o.itemID = a.itemID 
 AND mappingCode = @mappingCode
 AND a.pubDate = @pubDate
END
GO















CREATE PROCEDURE cf_getMapMultipleDated
@pubName varchar(50),
@sectionName1 varchar(50),
@sectionName2 varchar(50),
@sectionName3 varchar(50),
@startPubDate varchar(50) = '',
@endPubDate varchar(50) = ''
AS
IF (@startPubDate = '')
BEGIN
     SET @startPubDate = '1990-01-01'
END
IF (@endPubDate = '')
BEGIN
     SET @endPubDate = '2035-01-01'
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn
from viewTblActiveArticles
where pubName = @pubName
AND pubDate >= @startPubDate
AND pubDate <= @endPubDate
AND sectionName in ( @sectionName1, @sectionName2, @sectionName3 )
AND disableIndex = 0
order by pubDate desc, isnull(orderingRank,  999), updateDate desc
GO

















create proc cf_getMapOrderByPubDate
@mappingCode int,
@pubDate timestamp
AS
BEGIN
 SELECT a.itemID, a.docID, a.fileName, a.section, a.pubName, 
 a.pubDate, a.headline, o.rank
 FROM tblArticles a, tblArticleOrder o
 WHERE a.itemID = o.itemID
 AND o.mappingCode = @mappingCode
 AND a.pubDate = @pubDate
 AND a.approved > ''
 ORDER BY o.rank, a.updateDate desc 
END
GO
















CREATE PROCEDURE cf_getMapUndated
@pubName varchar(50),
@sectionName varchar(50),
@startPubDate varchar(50) = '',
@endPubDate varchar(50) = ''
AS
IF (@startPubDate = '')
BEGIN
     SET @startPubDate = '1990-01-01'
END
IF (@endPubDate = '')
BEGIN
     SET @endPubDate = getdate()
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn
from viewTblActiveArticles
where pubName = @pubName
AND sectionName = @sectionName
AND pubDate >= @startPubDate
AND pubDate <= @endPubDate
AND disableIndex = 0
order by isnull(orderingRank,  999), updateDate desc
GO

















CREATE PROCEDURE cf_getMapUndatedTopOne
@pubName varchar(50),
@sectionName varchar(50),
@startPubDate varchar(50) = '',
@endPubDate varchar(50) = ''
AS
IF (@startPubDate = '')
BEGIN
     SET @startPubDate = '1990-01-01'
END
IF (@endPubDate = '')
BEGIN
     SET @endPubDate = getdate()
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticles
where pubName = @pubName
AND sectionName = @sectionName
AND pubDate >= @startPubDate
AND pubDate <= @endPubDate
AND disableIndex = 0
AND orderingRank=1
order by isnull(orderingRank,  999), updateDate desc
GO

















create proc cf_getMonthDays
AS
BEGIN
 SELECT monthDayID, monthNameShort, monthID, dayNameShort, 
 dayName, dayID, numberDayOfMonth
 FROM tblMonthDay
END
GO















CREATE PROCEDURE cf_getNavigation
@pubName varchar(50)
AS
select *, image=sectionImage 
from viewNavigation
where pubName = @pubName
order by rank asc, sectionDesc asc
GO














CREATE procedure cf_getOzInclude
@sectionName varchar(50),
@fileName varchar(50),
@pubDate timestamp = '1950/01/01'
AS
-- declare @pubName variable
DECLARE @pubName varchar(50)
SELECT @pubName = 'oz'
SELECT body
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND fileName = @fileName
GO















CREATE PROCEDURE cf_getPublication
@pubName varchar(50)
AS
select tblPublications.* from tblPublications
where tblPublications.pubName = @pubName
GO











CREATE PROCEDURE cf_getPublicationArticles
@pubName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND disableIndex = 0
order by isnull(orderingRank,  999), sectionName, updateDate desc
GO











CREATE PROCEDURE cf_getRelatedLinks
@itemID int
AS
SELECT link, text from tblRelatedLinks
where itemID = @itemID
order by rank
GO











CREATE PROCEDURE cf_getSection
@pubName varchar(50),
@sectionName varchar(50)
AS
select *, image=sectionImage 
from viewPublicationsAndSections
where pubName = @pubName
and  sectionName = @sectionName
GO











CREATE PROCEDURE cf_getSectionAllPapers
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticles
where pubDate = @pubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by pubName, isnull(orderingRank,  999), updateDate desc
GO











CREATE PROCEDURE cf_getSectionArticles
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
articleTypeName,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn,
fullLink,
hostName
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by isnull(orderingRank,  999), updateDate desc
GO











CREATE PROCEDURE cf_getSectionArticlesIncludeBody
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20)
AS
SELECT *,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by isnull(orderingRank, isnull(pubRank, 999))
GO











CREATE PROCEDURE cf_getSectionArticlesMaxDate
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
articleTypeName,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn,
fullLink,
hostName,
rankBy = isnull(orderingRank, isnull(pubRank, 999))
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND pubDate <= getdate()
AND sectionName = @sectionName
AND disableIndex = 0
order by isnull(isnull(orderingRank, isnull(pubRank, 999)), 999)
GO











CREATE PROCEDURE cf_getSectionArticlesRollingArchive
@sectionName varchar(50),
@pubDate varchar(30) = '',
@daystopublish int = 3,
@pubName varchar(20)
AS
     SET @pubDate = convert(char(12), dateadd(day,-@daystopublish, getdate()) )
SELECT
pubDesc, 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline,
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
fullLink,
hostName
from viewTblActiveArticles
where pubName=@pubName
AND pubDate >= convert(timestamp,@pubDate)
AND sectionName = @sectionName
AND disableIndex = 0
AND pubDate <= getdate()
order by pubdate desc,isnull(orderingRank,  999)
GO











CREATE PROCEDURE cf_getSectionArticlesRollingArchiveNameSort
@sectionName varchar(50),
@pubDate varchar(30) = '',
@daystopublish int = 3,
@pubName varchar(20)
AS
     SET @pubDate = convert(char(12), dateadd(day,-@daystopublish, getdate()) )
SELECT
pubDesc, 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline,
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticles
where pubName=@pubName
AND pubDate >= convert(timestamp,@pubDate)
AND sectionName = @sectionName
AND disableIndex = 0
AND pubDate <= getdate()
order by pubDate desc,isnull(orderingRank,  999),fileName
GO











CREATE PROCEDURE cf_getSectionArticlesRollingArchiveOrderByPubDate
@sectionName varchar(50),
@pubDate varchar(30) = '',
@daystopublish int = 3,
@pubName varchar(20)
AS
     SET @pubDate = convert(char(12), dateadd(day,-@daystopublish, getdate()) )
SELECT
pubDesc, 
docID, 
viewTblActiveArticles..itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline,
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate()))
from viewTblActiveArticles
where pubName=@pubName
AND pubDate >= convert(timestamp,@pubDate)
AND sectionName = @sectionName
AND disableIndex = 0
AND pubDate <= getdate()
order by pubdate , isnull(orderingRank,  999)
GO










CREATE PROCEDURE cf_getSectionArticlesRollingMatt
@sectionName varchar(50),
@pubDate varchar(30) = '',
@daystopublish int = 3,
@pubName varchar(20)
AS

IF @pubDate = ''
BEGIN
     SET @pubDate = getdate() 
END

DECLARE @startDate timestamp
SELECT @startDate = convert(char(12), dateadd(day,-@daystopublish, @pubDate ))

SELECT
pubDesc, 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline,
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
fullLink,
hostName
from viewTblActiveArticles
where pubName=@pubName
AND pubDate >= @startDate
AND sectionName = @sectionName
AND disableIndex = 0
AND pubDate <= @pubDate
order by pubdate desc,isnull(orderingRank,  999)
GO











CREATE PROCEDURE cf_getSectionArticlesSorted
@pubName varchar(20),
@sectionName varchar(50),
@pubDate varchar(30) = '',
@daysToPublish int = 1,
@sort varchar(20)
AS
DECLARE @startPubDate varchar(12)
-- Set start pubDate to today, if not specified
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
-- Calculate offset
SET @startPubDate = convert(char(12), dateadd(day, -@daystopublish, @pubDate) )
IF (@sort = '' OR @sort = 'rank' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY isnull(orderingRank,  999), updateDate desc
END
IF ( @sort = 'dateDesc' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY pubdate desc, isnull(orderingRank,  999)
END
IF ( @sort = 'dateAsc' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY pubdate desc, isnull(orderingRank,  999)
END
IF ( @sort = 'headline' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY headline
END
IF ( @sort = 'headline2' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY headline2
END
IF ( @sort = 'fileName' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY fileName
END
IF ( @sort = 'articleLeadIn' )
BEGIN
 SELECT docID, viewTblActiveArticles.itemID, fileName, versionNum, 
     pubName, pubDate, section, headline, headline2, lead, 
     webLead, dateline, keywords, pubRank, pubData, byline, 
     bycredit, updateDate, docType, disableArticle, disableIndex, 
     approved, shortTime, dayOfWeek, virtualFolder, 
     pubSectionDesc, pubYear, pubMonth, pubDay, dateFolder, 
     pubDateLong, articleLeadIn, sigImage, sigImageCaption, 
     articleTypeName, listImage, listImageCaption, articleImage, 
     articleImageCaption, relatedLinksCount, sectionName, 
     sectionDesc, sigDir, sectionImage, orderingRank, 
     itemName = articleImage, caption = articleImageCaption, 
     relatedCount = relatedLinksCount, 
     MinuteNow = CONVERT(varchar(2), DATEPART(MI, GETDATE())), 
     HourNow = CONVERT(varchar(2), DATENAME(hour, GETDATE())), 
     leadIn
 FROM viewTblActiveArticles
 WHERE pubName=@pubName
       AND pubDate >= convert(timestamp,@pubDate)
       AND sectionName = @sectionName
       AND disableIndex = 0
       AND pubDate <= @startPubDate
 ORDER BY articleLeadIn
END
GO











CREATE PROCEDURE cf_getSectionArticlesSortedByName
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
viewTblActiveArticles..itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
articleTypeName,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
fullLink,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by isnull(orderingRank,  999), fileName, updateDate desc
GO











CREATE PROCEDURE cf_getSectionArticlesTemp
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
SELECT 
docID, 
viewTblActiveArticles.itemID, 
fileName,
versionNum, 
pubName, 
pubDate, 
section, 
headline, 
headline2, 
lead, 
webLead,
dateline, 
keywords, 
pubRank, 
pubData, 
byline, 
bycredit, 
updateDate, 
docType, 
disableArticle,
disableIndex,
approved,
shortTime ,
dayOfWeek  ,
virtualFolder,
pubSectionDesc,
pubYear, 
pubMonth ,
pubDay,
dateFolder,
pubDateLong ,
articleLeadIn ,
sigImage ,
sigImageCaption ,
articleTypeName,
listImage,
listImageCaption,
articleImage ,
articleImageCaption, 
relatedLinksCount ,
sectionName,
sectionDesc,
sigDir,
sectionImage ,
orderingRank,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount,
MinuteNow = convert(varchar(2),datepart(MI,getdate())),
HourNow = convert(varchar(2),datename(hour,getdate())),
leadIn
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND disableIndex = 0
order by isnull(orderingRank,  999), updateDate desc
GO











CREATE PROCEDURE cf_getSectionArticlesWithRowcount
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20) = ''
AS
IF (@pubDate = '')
BEGIN
     SET @pubDate = convert(char(12), dateadd(hh,-4, getdate()) )
END
select maxRows=count(fileName)
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
AND disableIndex = 0
GO











create proc cf_getSectionParents
@pubName varchar(50)
AS
BEGIN
 SELECT * 
 FROM tblSections 
 WHERE pubName = @pubName
 AND sectionDesc > '' 
 ORDER BY sectionDesc 
END
GO











CREATE PROCEDURE cf_getSectionSpecifyRows
@pubName varchar(50),
@sectionName varchar(50),
@pubDate varchar(20)
AS
SELECT *,
itemName = articleImage,
caption = articleImageCaption,
relatedCount = relatedLinksCount
from viewTblActiveArticles
where pubName = @pubName
AND pubDate = @pubDate
AND sectionName = @sectionName
order by isnull(orderingRank, 999)
GO











CREATE PROC cf_searchAllArticles
@pubName varchar(50),
@searchBegin timestamp,
@fileName varchar(50) = '',
@keywords varchar(100) = ''
AS
BEGIN
  if (@keywords = '') 
  BEGIN
    SELECT pubName, fileName, virtualFolder, dateFolder, pubDate, docID, versionNum,
    headline, sectionName, sectionDesc, disableArticle from viewAllArticles a
    WHERE a.pubName = @pubName
    AND a.pubDate = @searchBegin
    AND a.fileName like '%' + @fileName + '%'
  END
  ELSE
  BEGIN
    SELECT pubName, fileName, virtualFolder, dateFolder, pubDate, docID, versionNum,
    headline, sectionName, sectionDesc, disableArticle from viewAllArticles a
    WHERE a.pubName = @pubName
    AND a.pubDate = @searchBegin
    AND a.fileName like '%' + @fileName + '%'
    AND a.keywords like '%' + @keywords + '%'
  END    
END
GO











CREATE PROC cf_searchAllArticlesByMappingCode
@pubName varchar(50),
@searchBegin timestamp,
@searchEnd timestamp,
@mappingCode int,
@fileName varchar(50) = '',
@keywords varchar(100) = ''
AS
BEGIN
    SELECT pubName, fileName, virtualFolder, dateFolder, pubDate, docID, versionNum,
    headline, sectionName, sectionDesc, disableArticle from viewAllArticles a
    WHERE a.pubName = @pubName
    AND a.pubDate >= @searchBegin 
    AND a.pubDate <= @searchEnd
    AND a.fileName like '%' + @fileName + '%'
    AND a.keywords like '%' + @keywords + '%'
    AND a.mappingCode = @mappingCode
END
GO











CREATE PROC cf_searchAllArticlesBySection
@pubName varchar(50),
@searchBegin timestamp,
@searchEnd timestamp,
@section varchar(50),
@fileName varchar(50) = '',
@keywords varchar(100) = ''
AS
BEGIN
    SELECT pubName, fileName, virtualFolder, dateFolder, pubDate, docID, versionNum,
    headline, sectionName, sectionDesc, disableArticle from viewAllArticles a
    WHERE a.pubName = @pubName
    AND a.pubDate >= @searchBegin
    AND a.pubDate <= @searchEnd
    AND a.fileName like '%' + @fileName + '%'
    AND a.keywords like '%' + @keywords + '%'
    AND a.section = @section
END
GO











CREATE PROC cf_searchArticleInfoByDocID
@docID int
AS
BEGIN
  SELECT section, leadIn, pubName, headline, headline2, lead, webLead, dateline, keywords, pubData, byline,
  bycredit, versionNum, disableArticle, disableIndex, fileName, approved, webHeadline, pubRank, pubYear, 
  pubMonth, pubDay, pubDate, itemID, articleType, articleTypeID, body, customURL
  FROM viewAllArticles WHERE docID = @docID 
END
GO











CREATE PROC cf_searchArticleOrderDetailByItemId
@itemID int
AS
BEGIN
 SELECT * from tblArticleOrder WHERE itemID = @itemID
END
GO











CREATE PROC cf_searchArticleTypesByPub
@pubName varchar(50)
AS
BEGIN
  SELECT * from tblArticleTypes where pubName = @pubName
END
GO











CREATE PROC cf_searchDetailedArticleInfoByDocID
@docID int
AS
BEGIN
 SELECT section, leadIn, pubName, headline, headline2, lead, webLead, dateline, keywords, pubData, byline,
 bycredit, versionNum, disableArticle, disableIndex, fileName, approved, webHeadline, pubRank, pubYear, 
 pubMonth, pubDay, pubDate, itemID, articleType, articleTypeID, body, customURL
 from viewAllArticles WHERE docID = @docID
END
GO











CREATE PROC cf_searchItemIDbyDocID
@docID int
AS
BEGIN
 SELECT itemID from viewAllArticles where docID = @docID
END
GO











CREATE PROC cf_searchRelatedLinksByItemID
@itemID int
AS
BEGIN
 SELECT link, text, rank
 FROM tblRelatedLinks
 WHERE itemID = @itemID
 ORDER BY rank  
END
GO











CREATE PROC cf_searchSectionsByMappingCode
@mappingCode int
AS
BEGIN
 SELECT * FROM tblSections where mappingCode = @mappingCode
END
GO











CREATE PROCEDURE s_deleteGroup
@in_groupID int


AS
BEGIN
	DELETE FROM tblPermGroups
	WHERE groupID = @in_groupID

	IF @@ERROR <> 0 
		BEGIN
			RAISERROR ('ERROR: AN ERROR OCCURED DURING DELETION OF TBLPERMGROUPS.', 16, 1)
			RETURN(99)
		END
END
SELECT returnValue = '0'
GO











CREATE PROCEDURE s_deleteGroupType
@in_groupTypeID int

AS


BEGIN
	DELETE FROM tblPermGroupType
	WHERE groupTypeID = @in_groupTypeID;

 	IF @@ERROR <> 0 
 		BEGIN
  			RAISERROR ('ERROR: AN ERROR OCCURED DURING DELETION TBLPERMGROUPTYPE.', 16, 1)
  			RETURN(99)
 		END
 	 SELECT returnValue = 1
END
GO











CREATE PROCEDURE s_deleteMap
@itemID int,
@mappingCode int
AS
IF ( (@itemID = '') OR (@mappingCode = '') OR @itemID IS NULL OR @mappingCode IS NULL)
BEGIN
 PRINT "Required fields were not sent"
 RETURN(99)
END

DECLARE @mainMapCode int
SELECT @mainMapCode = mappingCode
FROM tblArticles, tblSections
WHERE tblArticles.section = tblSections.section
and tblArticles.pubName = tblSections.pubName
and itemID = @itemID

IF (@mainMapCode = @mappingCode)
BEGIN
  PRINT "Attempted to delete primary mapping code.  Not permitted."
  RETURN(99)
END

DELETE FROM tblArticleOrder
WHERE mappingCode = @mappingCode
AND  itemID = @itemID
update tblArticles 
set updateDate = getdate()
where itemID = @itemID

SELECT returnValue = '0'
GO











CREATE PROCEDURE s_deleteMultimedia 
@idNum int
AS
BEGIN
 -- if required fields are not sent, return an error
 if (@idNum= '') 
 BEGIN
  RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1)
  RETURN(99)
 END
 DECLARE @itemID int
 SELECT DISTINCT @itemID = itemID
 FROM tblMultimedia
 WHERE multimediaID  = @idNum
 -- Delete 
 DELETE from tblMultimedia
 WHERE multimediaID  = @idNum
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED DELETING THE IMAGE', 16,1)
   RETURN(99)
 END
             UPDATE tblArticles 
             SET updateDate = getdate()
             WHERE itemID = @itemID
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED DELETING THE IMAGE', 16,1)
   RETURN(99)
 END
SELECT returnValue = '0'
END
GO











CREATE PROC s_deleteRelatedLinkByItemID
@itemID int,
@link varchar(255)
AS
BEGIN
 DELETE from tblRelatedLinks
 WHERE itemID = @itemID
 AND link = @link
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED DELETING THE RELATED LINK', 16,1)
   RETURN(99)
 END
 UPDATE tblArticles 
             SET updateDate = getdate()
             WHERE itemID = @itemID
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED UPDATING THE UPDATE DATE', 16,1)
   RETURN(99)
 END
SELECT ITEMID = @itemID
END
GO











CREATE PROCEDURE s_deleteUser      
@in_userID int

AS

BEGIN
	IF (@in_userID = '0') 
 	   RETURN(99)

		DELETE FROM tblPermUsers
		WHERE userID = @in_userID

		IF (@@ERROR <> 0)
			BEGIN
				RAISERROR ('ERROR: AN ERROR OCCURED DELETING USER FROM tblPermUsers', 16, 1)
				RETURN(99)
			END				
				
		DELETE FROM tblPermUserGroup
		where userID = @in_userID
		
		IF (@@ERROR <> 0)
			BEGIN
				RAISERROR ('ERROR: AN ERROR OCCURED DELETING USER FROM tblPermUserGroup', 16, 1)
				RETURN(99)
			END

SELECT returnValue = '0'
END
GO











CREATE PROCEDURE s_editGroup

@in_groupID int,
@in_groupName varchar(500),
@in_groupDesc varchar(500),
@in_groupType int

AS

BEGIN

	DECLARE @in_action varchar(50)
	DECLARE @in_newgroupid int
  	IF (@in_groupID = '0')
  		SET @in_action = 'insert'
  	ELSE
    	SET @in_action = 'update' 	

	IF (@in_action = 'update')
		BEGIN
			UPDATE tblPermGroups 
			SET groupname = @in_groupName,
			groupdesc = @in_groupDesc,
			grouptype = @in_groupType
			WHERE groupid = @in_groupID
			
			SET @in_newgroupid = @in_groupID;
 			IF @@ERROR <> 0 
 				BEGIN
  					RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATE OF TBLPERMGROUPS.', 16, 1)
  					RETURN(99)
 				END
		END

	IF (@in_action = 'insert')
		BEGIN 
			INSERT INTO tblPermGroups
			(groupname, groupdesc, grouptype)
			VALUES (@in_groupName, @in_groupDesc, @in_groupType)
			SET @in_newgroupid = @@IDENTITY
 			IF @@ERROR <> 0 
 				BEGIN
  					RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATE OF TBLPERMGROUPS.', 16, 1)
  					RETURN(99)
 				END
 		END
	SELECT GROUPID = @in_newgroupid
END
GO











CREATE PROCEDURE s_editGroupToPub

@in_groupID int,
@in_pubID int,
@in_delete int


AS
BEGIN
	
	DECLARE @in_ifexists int;

	SET @in_ifexists = (SELECT count(*) 
	FROM tblPermGroupPublication 
	WHERE groupID = @in_groupID 
	AND pubID = @in_pubID)
   
	IF (@in_ifexists = '0')
		BEGIN
			IF (@in_delete = '0')
				INSERT INTO goon.tblPermGroupPublication
				VALUES(@in_groupID,@in_pubID)
		END
  	ELSE
  		IF (@in_ifexists > '0')
  			BEGIN
				IF (@in_delete = '1')
					DELETE FROM goon.tblPermGroupPublication
					WHERE groupID = @in_groupID
					AND pubID = @in_pubID
			END

select returnValue = 0
END
GO











CREATE PROCEDURE s_editGroupType

@in_grouptypeID int,
@in_groupTypeName varchar(500),
@in_groupTypeDesc varchar(500)



AS
BEGIN

	DECLARE @in_action varchar(50)
	DECLARE @in_newgrouptypeid int


	IF (@in_grouptypeID = '0')
		SET @in_action = 'insert'
	ELSE
		SET @in_action = 'update' 	

	IF (@in_action = 'update')
		BEGIN
			UPDATE tblPermGroupType 
			SET grouptypename = @in_groupTypeName,
			grouptypedesc = @in_grouptypeDesc
			WHERE grouptypeid = @in_grouptypeID
      
			SET @in_newgrouptypeid = @in_groupTypeID
			IF @@ERROR <> 0 
				BEGIN
					RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATING TBLPERMGROUPTYPE.', 16, 1)
					RETURN(99)
				END
		END
	IF (@in_action = 'insert')
		BEGIN 
			INSERT INTO tblPermGroupType 
			(grouptypename, grouptypedesc)
			VALUES (@in_groupTypeName, @in_groupTypeDesc);
      
		IF @@ERROR <> 0 
			BEGIN
				RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMGROUPTYPE.', 16, 1)
				RETURN(99)
			END
		END
	SELECT returnValue = 1
END
GO











CREATE PROCEDURE s_editUser

@in_userID int,
@in_userName varchar(500),
@in_userPassword varchar(500),
@in_lastname varchar(500),
@in_firstName varchar(500),
@in_homepub int,
@in_email varchar(500),
@in_workPhone varchar(500),
@in_cellPhone varchar(500),
@in_pager varchar(500),
@in_notes varchar(500)


AS
BEGIN
	DECLARE @in_action varchar(50)
	DECLARE @in_newuserid int

		IF (@in_userID = '0')
			SET @in_action = 'insert'
		ELSE
			SET @in_action = 'update' 	

		IF (@in_action = 'update')
			BEGIN
				UPDATE tblPermUsers 
				SET 
				username = @in_userName,
				userpassword = @in_userPassword,
				lastname = @in_lastName,
				firstname = @in_firstName,
				homepub = @in_homepub,
				email = @in_email,
				workphone = @in_workPhone,
				cellphone = @in_cellPhone,
				pager = @in_pager,
				notes = @in_notes
				WHERE userid = @in_userID
				
				SET @in_newuserid = @in_userid
				IF (@@ERROR <> 0)
					BEGIN
						RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMUSERS.', 16, 1)
						RETURN(99)
					END
			END

	IF (@in_action = 'insert')
		BEGIN 

			DECLARE @duplicateUser int
			SET @duplicateUser = (SELECT count(*) FROM tblPermUsers WHERE userName = @in_userName)
			IF (@duplicateUser > 0)
				BEGIN
					SELECT DUPLICATE = @in_userName
					RETURN(99)
				END
			INSERT INTO tblPermUsers
			(username, userpassword, lastname, firstname, homepub, email, workphone, cellphone, pager, notes)
			VALUES (@in_userName, @in_userPassword, @in_lastName, @in_firstName, @in_homepub, @in_email, @in_workPhone, @in_cellPhone, @in_pager, @in_notes);
      		SET @in_newuserid  = (SELECT @@IDENTITY)
      		
			IF (@@ERROR <> 0)
				BEGIN
					RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMUSERS.', 16, 1)
					RETURN(99)
				END
		END
select USERID = @in_newuserid

END
GO











CREATE PROCEDURE s_editUserToGroup

@in_userID int,
@in_groupID int,
@in_action int

AS
BEGIN
	DECLARE @ifexists int
	SET @ifexists = (SELECT count(*)
	FROM tblPermUserGroup
	WHERE userID = @in_userID
	AND groupID = @in_groupID)

	IF (@ifexists = '0')
		BEGIN
			IF (@in_action = '1')  
				INSERT into tblPermUserGroup
				values (@in_userID, @in_GroupID)
		END

	IF (@ifexists = '1')
		BEGIN
			IF (@in_action = '0') 
				DELETE FROM tblPermUserGroup
				WHERE userID = @in_userID
				AND groupID = @in_GroupID
		END

	IF @@ERROR <> 0 
		BEGIN
			RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATING  OF TBLPERMUSERTOGROUP.', 16, 1)
			RETURN(99)
		END
	SELECT returnValue = '0'
END
GO









CREATE PROCEDURE s_insertArticle 
@pubName varchar(50), 
@section varchar(50), 
@pubDate varchar(50), 
@fileName varchar(50), 
@approved varchar(50) , 
@headline varchar(1000) ='', 
@headline2 varchar(1000) ='', 
@lead varchar(1000) ='', 
@byline varchar(255) ='',    
@bycredit varchar(255) ='',    
@dateline varchar(100) ='',    
@body text ='',    
@leadIn varchar(255) ='', 
@webHeadline varchar(1000) ='', 
@keywords varchar(1000) ='',    
@webLead varchar(1000) ='',    
@pubRank varchar(25) ='',   
@pubData varchar(1000) ='',    
@disableIndex int =0, 
@disableArticle int =0, 
@rank int = 999, 
@articleType varchar(50) = '', 
@noVersioning int = 1, 
@customURL varchar(255)=null 
AS 
 
-- Remove the next line to turn on versioning (workflow) functionality 
SET @noVersioning = 1 
 
 
 
-- if required fields are not sent, return an error 
if (@section = '') OR (@pubName = '') OR (@fileName = '') OR (@pubDate = '') 
BEGIN 
   RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1) 
   RETURN(99) 
END 
/* 
declare @validsection int 
select @validsection = count(section) from tblSections 
WHERE pubName = @pubName and section = @section 
AND pubName = @pubName 
if(@validsection < 1) 
Begin 
	select @validsection = count(sectionName) from tblSections 
	WHERE sectionName = @section AND pubName = @pubName 
	if(@validsection = 1) 
	Begin 
	  select @section = section from tblSections 
	  WHERE sectionName = @section AND pubName = @pubName 
	End 
End 
*/ 
if @rank = 0 
BEGIN 
  SET @rank = 999 
END 
 
-- Get ArticleTypeID. If null, insert 0 
DECLARE @articleTypeID int 
SELECT @articleTypeID = ISNULL( articleTypeID, 0 ) 
 FROM tblArticleTypes 
 WHERE pubName = @pubName 
 AND articleType = @articleType  
IF ( @articleTypeID IS NULL )  
begin 
 SELECT @articleTypeID = 0 
end 
IF @@ERROR <> 0  
BEGIN 
 RAISERROR('AN ERROR HAS OCCURED ON GETTING THE ARTICLE TYPE ID', 16, 1) 
  RETURN(99) 
END 
 
 
-- Get version number to insert 
DECLARE @verNum int 
SELECT @verNum = isnull(max(versionNum), 0) + 1 
FROM tblArticles  
WHERE section = @section 
AND pubDate = @pubDate 
AND pubName = @pubName 
AND fileName = @fileName 
IF @@ERROR <> 0  
BEGIN 
 RAISERROR('AN ERROR HAS OCCURED ON GETTING THE VERSION NUMBER', 16, 1) 
  RETURN(99) 
END 
 
-- print 'versionnum = ' + cast(@vernum as char) 
 
 
 
DECLARE @itemID int 
SELECT @itemID =isnull(min(itemID) , 0) FROM tblArticles  
	WHERE section = @section 
	AND pubDate = @pubDate 
	AND pubName = @pubName 
	AND fileName = @fileName 
	--AND versionNum < @verNum --the min in the select means we don't care 
-- print 'initial itemID =' 
-- print @itemID 
IF @@ERROR <> 0  
BEGIN 
 RAISERROR('AN ERROR HAS OCCURED GETTING ITEMID', 16, 1) 
 RETURN(99) 
END 
 
if (@itemID > 0)  
BEGIN --check itemID 
  declare @idcount int 
  select @idcount = isnull(count(itemid),0) from tblArticles where itemid = @itemid 
  if @idcount > 1  
  begin 
    -- print 'dupped id' 
    delete tblArticles where section = @section 
	AND pubDate = @pubDate 	AND pubName = @pubName 
	AND fileName = @fileName -- all versions, cleanup 
    set @itemID = 0 
  end 
end 
 
----- IF (@itemID = 0 
IF (@itemID = 0) 
 
BEGIN 
 
  -- Insert into tblArticles 
  -- temp for 107 also itemID and docId IN the insert below 
  --select @itemID = max(itemID)+1 from tblarticles where itemid < 60000 
-- print 'new ID=' 
-- print @itemID 
  INSERT INTO tblArticles ( 
  pubName, pubDate,  versionNum,  section, fileName) --, itemID, docID )  
  VALUES ( 
  @pubName, @pubDate , @verNum,  @section ,  @fileName ) --,@itemID, @itemID)   
 
  IF @@ERROR <> 0  
  BEGIN 
   RAISERROR('AN ERROR HAS OCCURED ON THE INSERT', 16, 1) 
   RETURN(99) 
  END 
 
-- Get an itemID for this new article 
 
SELECT @itemID = @@IDENTITY 
update tblArticles set itemID = @itemID where docID = @itemID 
 
  IF @@ERROR <> 0  
  BEGIN 
   RAISERROR('AN ERROR HAS OCCURED ON UPDATING ITEMID', 16, 1) 
   RETURN(99) 
  END 
END ---IF (@itemID = 0 
 
 
-- print 'about to update' 
-- print @vernum 
-- print @itemID 
UPDATE tblArticles  
SET headline = @headline ,   headline2 = @headline2 ,    
webHeadline = @webHeadline,  lead = @lead ,    dateline = @dateline ,    
keywords = @keywords ,   webLead = @webLead, pubRank = @pubRank ,   
pubData = @pubData ,   byline = @byline ,   bycredit = @bycredit ,      
body = @body ,   leadIn = @leadIn, updateDate = getdate(),    versionNum = @verNum,   
approved = @approved,     disableIndex = @disableIndex, disableArticle = @disableArticle,  
articleTypeID = @articleTypeID, customURL = @customURL  
WHERE itemID = @itemID 
 
IF @@ERROR <> 0  
BEGIN 
 RAISERROR('AN ERROR HAS OCCURED ON UPDATING ARTICLE', 16, 1) 
 RETURN(99) 
END 
 
Delete from tblArticles  
where section = @section 
AND pubDate = @pubDate 
AND pubName = @pubName 
AND fileName = @fileName 
AND itemID <> @itemID 
 
IF @@ERROR <> 0  
BEGIN 
 RAISERROR('AN ERROR HAS OCCURED ON REMOVING OLD VERSIONS', 16, 1) 
 RETURN(99) 
END 
-- print 'about to set mapping'   
-- Set mappingCode 
BEGIN 
 DECLARE @mappingCode int 
 SELECT @mappingCode = mappingCode from tblSections 
 WHERE section = @section 
 AND pubName = @pubName 
  
 IF (@mappingCode IS NOT NULL) -- in other words if section is valid 
 BEGIN 
-- print @itemID 
-- print @mappingcode 
-- print @rank 
  exec s_insertMap @itemID, @mappingCode, @rank 
   
 END 
END 
 
-- print 'about to update ActiveArticles' 
 
-- Insert this article in tblActiveArticles 
-- remove after active articles deleted 
--exec s_updateActiveArticlesWithoutView @itemID 
 
-- print 'at end' 
 
 
 
SELECT itemID = @itemID 
GO











CREATE PROCEDURE s_insertArticleType
@articleTypeID int,
@pubName varchar(50),
@articleType varchar(50),
@articleTypeName varchar(50),
@articleTypeCategory varchar(50) ,
@articleTypeMappingCode int,
@articleTypeDisplayOnIndex int = 1,
@articleTypeDesc varchar(100) = '',
@articleTypeImage varchar(255) = '',
@articleTypeByline varchar(50) = '',
@articleTypeTitle varchar(50) = '',
@articleTypeLeadIn varchar(100) = '',
@articleTypeEmail varchar(50) = '', 
@articleTypeBio text = '',
@articleTypeShirtTail text = '',
@disableArticleType int = 0
AS
BEGIN
IF (@articleTypeID IS NULL) OR (@pubName = '') OR (@articleType = '') OR 
   (@articleTypeName = '') OR (@articleTypeCategory = '') OR 
   (@articleTypeMappingCode is NULL)
BEGIN
   RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1)
   RETURN(99)
END
IF NOT EXISTS(SELECT * FROM tblPublications WHERE pubName = @pubName)
BEGIN
   RAISERROR ('ERROR: PUBLICATION DOES NOT EXIST.', 16, 1)
   RETURN(99)
END
IF NOT EXISTS(SELECT distinct articleTypeCategory FROM tblArticleTypes 
 WHERE  articleTypeCategory = @articleTypeCategory)
BEGIN
   RAISERROR ('ERROR: CATEGORY CODE DOES NOT EXIST.', 16, 1)
   RETURN(99)
END
IF NOT EXISTS(SELECT distinct mappingCode FROM tblSections 
 WHERE mappingCode = @articleTypeMappingCode)
BEGIN
   RAISERROR ('ERROR: MAPPING CODE DOES NOT EXIST.', 16, 1)
   RETURN(99)
END
DECLARE @action varchar(10)
IF EXISTS(SELECT * FROM tblArticleTypes WHERE articleTypeID = @articleTypeID) AND (@articleTypeID > 0)
   SET @action = "update"
ELSE IF (@articleTypeID = 0)
   SET @action = "insert" 
ELSE
BEGIN
   RAISERROR ('ERROR: ARTICLETYPEID DOES NOT EXIST.', 16, 1)
   RETURN(99)
END
IF (@action = "update")
BEGIN
 UPDATE tblArticleTypes
 set pubName = @pubName, 
        articleType = @articleType, 
        articleTypeName = @articleTypeName, 
 articleTypeCategory = @articleTypeCategory, 
 articleTypeMappingCode = @articleTypeMappingCode, 
 articleTypeDisplayOnIndex = @articleTypeDisplayOnIndex, 
 articleTypeDesc = @articleTypeDesc, 
 articleTypeImage = @articleTypeImage,
 articleTypeByline = @articleTypeByline, 
 articleTypeTitle = @articleTypeTitle, 
 articleTypeLeadIn = @articleTypeLeadIn, 
 articleTypeEmail =@articleTypeEmail, 
 articleTypeBio =@articleTypeBio, 
 articleTypeShirtTail =@articleTypeShirtTail,
 disableArticleType = @disableArticleType,
articleTypeUpdateDate = getdate()
 where articleTypeID = @articleTypeID
 IF @@ERROR <> 0 
 BEGIN
  RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATING.', 16, 1)
  RETURN(99)
 END
END
IF (@action = "insert")
BEGIN
 INSERT tblArticleTypes(pubName, articleType, articleTypeName, articleTypeCategory, 
 articleTypeMappingCode, articleTypeDisplayOnIndex, articleTypeDesc, articleTypeImage,
 articleTypeByline, articleTypeTitle, articleTypeLeadIn, articleTypeEmail, 
 articleTypeBio, articleTypeShirtTail, disableArticleType, articleTypeUpdateDate)
 VALUES(@pubName,@articleType, @articleTypeName, @articleTypeCategory,
 @articleTypeMappingCode, @articleTypeDisplayOnIndex, @articleTypeDesc, @articleTypeImage,
 @articleTypeByline, @articleTypeTitle, @articleTypeLeadIn, @articleTypeEmail, 
 @articleTypeBio, @articleTypeShirtTail, @disableArticleType, getdate())
 IF @@ERROR <> 0 
 BEGIN
  RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTING.', 16, 1)
  RETURN(99)
 END
END
END
GO









CREATE PROCEDURE s_insertMap 
@itemID int, 
@mappingCode int, 
@rank int = 999, 
@timeStart timestamp = '1/1/1980', 
@timeEnd timestamp = '1/1/1980', 
@pubName varchar(50) = '', 
@section varchar(50) = '', 
@pubDate timestamp = '1951-06-07' 
AS 
	IF ( (@itemID = '') OR (@mappingCode = '') OR @itemID IS NULL OR @mappingCode IS NULL) 
	BEGIN 
		PRINT "Required fields were not sent" 
		RETURN(99) 
	END 
 
	IF (@timeStart = '1/1/1980') 
		SET @timeStart = getdate() 
	IF (@timeEnd = '1/1/1980') 
		SET @timeEnd = getdate() 
 
	select @pubName = pubName, @section = section from tblSections where mappingCode = @mappingCode 
	select @pubDate = pubDate from tblArticles where itemID = @itemID 
 
	DECLARE @doesExists int 
	SELECT @doesExists = count(*)  
	FROM tblArticleOrder 
	WHERE mappingCode = @mappingCode 
	AND  itemID = @itemID 
--print 'does exist' 
--print @doesexists 
	IF (@doesExists < 1 ) 
	BEGIN 
		INSERT INTO tblArticleOrder (itemID, mappingCode, rank) 
		values  (@itemID,  @mappingCode, @rank) 
		IF @@ERROR <> 0  
		BEGIN 
			RAISERROR('AN ERROR HAS OCCURED ON INSERTING MAPPING', 16, 1) 
			RETURN(99) 
		END 
	END  -- if does not exist 
	 
	update tblArticleOrder set 
	timeStart = @timeStart, rank = @rank, 
	timeEnd = @timeEnd, mappingUpdateDate = getdate(), 
	pubname = @pubname, section = @section, 
	pubDate = @pubDate 
	where itemID = @itemID and mappingCode = @mappingCode 
	IF @@ERROR <> 0  
	BEGIN 
		RAISERROR('AN ERROR HAS OCCURED ON UPDATING MAPPING', 16, 1) 
		RETURN(99) 
	END 
 
 
	UPDATE tblArticles  
             SET updateDate = getdate() 
             WHERE itemID = @itemID 
	IF @@ERROR <> 0  
	BEGIN  
		RAISERROR('AN ERROR HAS OCCURED UPDATING THE ARTICLE UPDATE DATE', 16,1) 
	 	RETURN(99) 
	END 
 
 
 
exec s_updateArticlePreload @itemID, @mappingCode 
GO











CREATE PROCEDURE s_insertMapFromCode
@pubName varchar(50),
@itemID int,
@section varchar(50),
@rank int = 999,
@timeStart timestamp = '1/1/1980',
@timeEnd timestamp = '1/1/1980'
AS
BEGIN
  -- if required fields are not sent, return an error
 if (@section = '') OR (@pubName = '') OR (@itemID = '')
 BEGIN
  RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1)
  RETURN(99)
 END
 DECLARE @mappingCode int
 SELECT @mappingCode = mappingCode from tblSections
 WHERE section = @section
 AND pubName = @pubName
 
 --If we don't have a valid mapping code...  
 IF (@mappingCode IS NULL) 
 BEGIN
  RAISERROR('SECTION %s DOES NOT EXIST', 16, 1, @section)
  RETURN(99)     
 END
 --If we do have a valid mapping code...  
 IF (@mappingCode IS NOT NULL) 
 BEGIN
  EXEC s_insertMap @itemID, @mappingCode, @rank, @timeStart, @timeEnd
 END
 IF @@ERROR <> 0 
 BEGIN
  RAISERROR('AN ERROR HAS OCCURED ON INSERTING MAPPING', 16, 1)
  RETURN(99)
  END
 
END
GO








CREATE PROCEDURE s_insertMappingCode2
@mappingCode int,
@subMapOf int,
@pubName varchar(50),
@section varchar(50),
@sectionName varchar(100),
@sectionDesc varchar(255) = '',
@sectionType int,
@image varchar(255) = '',
@sigDir varchar(255) = '',
@include varchar(5000) = '',
@promo varchar(5000) = '',
@rank int,
@url varchar(255) = '',
@displayOnIndex int
AS
BEGIN
 IF (@mappingCode IS NULL) OR (@subMapOf IS NULL) OR (@pubName = '') OR 
     (@section = '') OR (@sectionName = '') OR 
     (@sectionDesc = '') OR (@sectionType is NULL)
 BEGIN
  RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1)
  RETURN(99)
 END
 IF NOT EXISTS(SELECT * FROM tblPublications WHERE pubName = @pubName)
 BEGIN
  RAISERROR ('ERROR: PUBLICATION DOES NOT EXIST.', 16, 1)
  RETURN(99)
 END
 IF NOT EXISTS(SELECT distinct sectionType FROM tblSections
 WHERE  sectionType = @sectionType)
 BEGIN
  RAISERROR ('ERROR: SECTION TYPE DOES NOT EXIST.', 16, 1)
  RETURN(99)
 END
 DECLARE @action varchar(10)
 IF EXISTS(SELECT * FROM tblSections WHERE  mappingCode = @mappingCode) AND (@mappingCode > 0)
  SET @action = "update"
 ELSE IF (@mappingCode = 0)
  SET @action = "insert" 
 ELSE
 BEGIN
  RAISERROR ('ERROR: MAPPINGCODE DOES NOT EXIST.', 16, 1)
  RETURN(99)
 END
 IF (@action = "update")
 BEGIN
  UPDATE tblSections  
  SET section = @section,
  sectionName = @sectionName,
  sectionDesc = @sectionDesc,
  subMapOf = @subMapOf,
  image = @image,
  sigDir = @sigDir,
  sectionType = @sectionType,
  include = @include,
  promo = @promo,
  rank = @rank,
  url = @url,
  displayOnIndex = @displayOnIndex,
  sectionUpdateDate = getdate()
  WHERE mappingCode  = @mappingCode
  IF @@ERROR <> 0 
  BEGIN
   RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATING.', 16, 1)
   RETURN(99)
  END
 END
 IF (@action = "insert")
 BEGIN
  INSERT INTO tblSections (pubName, section, sectionDesc, sectionName,  image, 
  orderFile, sigDir, subMapOf, sectionType, include, promo,rank,url,displayOnIndex, sectionUpdateDate)
  VALUES (@pubName, @section, @sectionDesc, @sectionName, @image, 
   '', @sigDir, @subMapOf, @sectionType, @include, @promo, @rank, @url, @displayOnIndex, getdate()) 
  IF @@ERROR <> 0 
  BEGIN
   RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTING.', 16, 1)
   RETURN(99)
  END
 END
SELECT returnValue = '0'
END
GO











CREATE PROCEDURE s_insertMultimedia
@itemID int,
@type varchar(50) ,
@itemName varchar(1000) ,
@caption varchar(1000) = '',
@mimeType varchar(50) = '',
@rank int = 999,
@credit varchar(100) = ''
AS
 -- adjust rank if neccessary
 IF @rank = 0
 BEGIN
  set @rank = 999
 END
 -- Delete if already exists
 DELETE from tblMultimedia
 WHERE type = @type
 AND itemID = @itemID
 -- Insert into tblMultimedia
 INSERT INTO tblMultimedia (
  itemID, type, itemName, mimeType, caption, rank, credit, multimediaUpdateDate) 
 VALUES ( 
 @itemID, @type, 
 @itemName, @mimeType, @caption, @rank, @credit, getdate()) 
 IF @@ERROR <> 0 
 BEGIN
  RAISERROR('AN ERROR HAS OCCURED ON THE INSERT', 16, 1)
  RETURN(99)
 END
 UPDATE tblArticles 
             SET updateDate = getdate()
             WHERE itemID = @itemID
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED UPDATING THE UPDATE DATE', 16,1)
   RETURN(99)
 END


update tblArticlePreload 
set listImage = (SELECT isNull(itemName, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='sectionImage'), 
listImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='sectionImage'), 
articleImage = (SELECT isNull(itemName, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='articleImage'), 
articleImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='articleImage')
where itemID = @itemID
select returnval = '0'
GO











CREATE PROCEDURE s_insertPublication
@publication varchar(50),
@pubName varchar(50),
@pubDesc varchar(100),
@tagLine varchar(100) = "",
@homePage varchar(100) = "",
@icon char(100) = "",
@iconWidth int,
@iconHeight int,
@javaScript varchar(1000) = "",
@rolloverTime int = 4,
@defaultSection varchar(100),
@defaultSectionWithDate int,
@domainName  varchar(100) = "",
@testFTPServer  varchar(500) = "",
@testFTPLogin  varchar(100) = "",
@testFTPPassword  varchar(100) = "",
@testTemplateFolder  varchar(100) = "",
@testImagesFolder  varchar(100) = "",
@liveFTPServer  varchar(500) = "",
@liveFTPLogin  varchar(100) = "",
@liveFTPPassword  varchar(100) = "",
@liveTemplateFolder  varchar(100) = "",
@liveImagesFolder   varchar(100) = "",
@liveImagesServer   varchar(500) = "",
@importFTPServer   varchar(500) = "",
@importFTPLogin   varchar(100) = "",
@importFTPPassword   varchar(100) = "",
@importFTPFilePath   varchar(100) = "",
@importFTPFileContents    varchar(100) = "",
@mainCofaxServer    varchar(100) = "",
@imagesURLPrefix    varchar(100) = "",
@cacheServers       varchar(500) = "",
@pubID int=0
AS
BEGIN
 IF (@publication IS NULL) OR (@pubName IS NULL) OR (@pubDesc = '') 
 BEGIN
     RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1)
     RETURN(99) 
 END
 -- Get publication Action
 DECLARE @action varchar(10)
 IF EXISTS(SELECT * FROM tblPublications WHERE  pubID = @pubID) AND (@pubID > 0)
     SET @action = "update"
 ELSE IF (@pubID = 0)
     SET @action = "insert" 
 ELSE
 BEGIN
     RAISERROR ('ERROR: Publication DOES NOT EXIST.', 16, 1)
     RETURN(99)
 END
 -- Get pubConfigAction
 DECLARE @pubConfigAction varchar(10)
 IF EXISTS(SELECT * FROM tblToolsPublicationConfig WHERE  pubID = @pubID) AND (@pubID > 0)
     SET @pubConfigAction = "update"
 ELSE 
  SET @pubConfigAction = "insert" 
 
 IF (@action = "update")
 BEGIN
   UPDATE tblPublications
   SET  publication = @publication,
   pubName = @pubName,
   pubDesc = @pubDesc,
   tagLine = @tagLine,
   homePage = @homePage,
   icon = @icon,
   iconWidth = @iconWidth,
   iconHeight = @iconHeight,
   javaScript = @javascript,
   rolloverTime = @rollovertime,
  defaultSection = @defaultSection,
  defaultSectionWithDate = @defaultSectionWithDate,
                           pubUpdateDate = getdate()
   WHERE pubID  = @pubID
  IF @@ERROR <> 0 
   BEGIN
     RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATING.', 16, 1)
     RETURN(99)
   END
 END
 IF (@action = "insert")
 BEGIN
  INSERT INTO tblPublications(publication, pubName, pubDesc, tagLine,  homePage, 
  icon, iconWidth, iconHeight, javaScript, rolloverTime,defaultSection,defaultSectionWithDate, pubUpdateDate)
   VALUES (@publication, @pubName, @pubDesc, @tagLine, @homePage, 
   @icon,@iconWidth,@iconHeight,@javaScript,@rolloverTime,@defaultSection,@defaultSectionWithDate, getdate()) 
   IF @@ERROR <> 0 
  BEGIN
     RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTING.', 16, 1)
     RETURN(99)
   END
  SET @pubID = @@IDENTITY
 END
 IF (@pubConfigAction = "update")
 BEGIN
  UPDATE tblToolsPublicationConfig 
  SET domainName = @domainName,
          testFTPServer = @testFTPServer,
          testFTPLogin = @testFTPLogin,
          testFTPPassword = @testFTPPassword,
          testTemplateFolder = @testTemplateFolder,
          testImagesFolder = @testImagesFolder,
          liveFTPServer = @liveFTPServer,
          liveFTPLogin = @liveFTPLogin,
          liveFTPPassword = @liveFTPPassword,
          liveTemplateFolder = @liveTemplateFolder,
          liveImagesFolder = @liveImagesFolder,
          liveImagesServer = @liveImagesServer,
           importFTPServer = @importFTPServer,
           importFTPLogin = @importFTPLogin,
          importFTPPassword = @importFTPPassword,
          importFTPFilePath = @importFTPFilePath,
          importFTPFileContents = @importFTPFileContents,
          mainCofaxServer = @mainCofaxServer,
                           cacheServers = @cacheServers,
          imagesURLPrefix = @imagesURLPrefix
          where pubID = @pubID
  IF @@ERROR <> 0 
   BEGIN
     RAISERROR ('ERROR: AN ERROR OCCURED DURING UPDATING.', 16, 1)
     RETURN(99)
   END
 END
 IF (@pubConfigAction = "insert")
 BEGIN
  INSERT  tblToolsPublicationConfig 
  values(@pubID, @domainName, @testFTPServer,  @testFTPLogin,
         @testFTPPassword, @testTemplateFolder, @testImagesFolder,
         @liveFTPServer, @liveFTPLogin, @liveFTPPassword,
         @liveTemplateFolder, @liveImagesFolder, @liveImagesServer, @importFTPServer,
          @importFTPLogin, @importFTPPassword,@importFTPFilePath,
         @importFTPFileContents,@mainCofaxServer,@imagesURLPrefix, @cacheServers)
      IF @@ERROR <> 0 
      BEGIN
         RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTING.', 16, 1)
         RETURN(99)
      END
 END 
 SELECT pubID = @pubID
END
GO











CREATE PROCEDURE s_insertRelatedLink
@pubName varchar(50),
@itemID int,
@link varchar(255),
@text varchar(500),
@rank int = 999
AS
BEGIN
 -- if required fields are not sent, return an error
 if (@link = '') OR (@pubName = '') OR (@itemID = '')
 BEGIN
      RAISERROR ('ERROR: REQUIRED FIELDS WERE NOT SENT.', 16, 1)
  RETURN(99)
 END
 
 INSERT INTO tblRelatedLinks
 ( itemID, link, rank, text, linkUpdateDate )
 VALUES   ( @itemID, @link, @rank, @text, getdate() )
 IF @@ERROR <> 0 
 BEGIN
  RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTING.', 16, 1)
  RETURN(99)
 END
 UPDATE tblArticles 
             SET updateDate = getdate()
             WHERE itemID = @itemID
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED UPDATING THE UPDATE DATE', 16,1)
   RETURN(99)
 END
 
END
GO











CREATE PROC s_insertRelatedLinkByItemID
@itemID int,
@link varchar(255),
@linkText varchar(255),
@rank int
AS
BEGIN
 INSERT INTO tblRelatedLinks
 (itemID, link, text, rank, linkUpdateDate)
 VALUES (@itemID, @link, @linkText, @rank, getdate())      
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED INSERTING THE RELATED LINK', 16,1)
   RETURN(99)
 END
 UPDATE tblArticles 
             SET updateDate = getdate()
             WHERE itemID = @itemID
 IF @@ERROR <> 0 
 BEGIN 
  RAISERROR('AN ERROR HAS OCCURED UPDATING THE UPDATE DATE', 16,1)
   RETURN(99)
 END
SELECT ITEMID = @itemID
END
GO









CREATE PROCEDURE s_updateActiveArtDisArtDisIn
@in_itemID int,
@in_disablearticle int,
@in_disableindex int

AS 
BEGIN

  UPDATE tblarticles 
  SET disablearticle = @in_disablearticle,
  disableindex = @in_disableindex
  WHERE itemid = @in_itemid;


SELECT returnValue = '0'
END
GO











CREATE PROCEDURE s_updateArticleDisableSection
@in_itemID int,
@in_disableIndex int,
@in_disableArticle int

AS
BEGIN

DECLARE @ret_value int;
DECLARE @in_verNum int;
DECLARE @cur_disableIndex int;
DECLARE @cur_disableArticle int;

   	SELECT @cur_disableIndex = disableindex, @cur_disableArticle = disablearticle 
  	FROM tblarticles
  	WHERE itemid = @in_itemID  
    
  IF (@cur_disableIndex != @in_disableIndex) OR (@cur_disableArticle != @in_disableArticle)
     	 BEGIN
	  	UPDATE tblArticles SET 
	  	disableArticle = @in_disableArticle,
	  	disableIndex = @in_disableIndex 
	  	WHERE itemID = @in_itemID;
	  	IF (@@ERROR <> 0)
	   		BEGIN
	   			RAISERROR ('ERROR: AN ERROR OCCURED UPDATING TBLACTIVEARTICLES', 16, 1)
	   			RETURN(99)
			END				
	END  

exec s_updateActiveArtDisArtDisIn @in_itemID, @in_disableIndex, @in_disableArticle

  	
select ITEMID = @in_itemID
 
END
GO









CREATE proc s_updateArticlePreload 
@itemID int, 
@mappingCode int = -1 
AS 
BEGIN 
 
	insert into tblArticlePreload (itemID, mappingCode)  
	select o.itemid, o.mappingCode from tblArticleOrder o  
		left outer join tblArticlePreload p on o.itemid = p.itemID and o.mappingcode = p.mappingcode 
		where o.itemid = @itemid and p.itemID is null 
	IF @@ERROR <> 0  
 	BEGIN 
		RAISERROR('AN ERROR HAS OCCURED ON INSERTING ARTICLE PRELOAD', 16, 1) 
		RETURN(99) 
	END 
 
             -- TO DO This is a HACK!!! 
             DECLARE @virtualFolder varchar(255) 
             DECLARE @pubSectionDesc varchar(255) 
             DECLARE @fullLink          varchar(255) 
 
 
select @virtualFolder = tblArticles.pubName +  
              "/" + convert(varchar(4), datepart(year, tblArticles.pubDate) )  +  
	 "/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
	  "/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2) + 
	             "/" + tblSections.sectionName, 
@pubSectionDesc =  tblSections.sectionDesc , 
@fullLink = 
	CASE   
	WHEN tblArticles.customURL = '' OR tblArticles.customURL IS NULL THEN tblPublications.hostName + 'content' +  
	              '/' + tblArticles.pubName +  
	              '/' + convert(varchar(4), datepart(year, tblArticles.pubDate) )  + 
	              '/' + right( replicate("0", 2) + convert(varchar(2), datepart(month, tblArticles.pubDate)), 2) + 
	             '/' + right( replicate("0", 2) + convert(varchar(2), datepart(day, tblArticles.pubDate)), 2) +  
	             '/' + tblSections.sectionName  + 
	            '/' + fileName + '.htm' 
	ELSE tblArticles.customURL 
	END 
from tblArticles,  tblPublications,  tblSections 
	WHERE tblArticles.pubName = tblPublications.pubName 
	--AND tblArticles.articleTypeID *= tblArticleTypes.articleTypeID 
	--AND tblArticles.disableArticle = 0	 
--AND tblArticleTypes.disableArticleType = 0 
	AND tblArticles.pubName = tblSections.pubName 
	AND tblArticles.section = tblSections.section 
	AND tblArticles.itemID = @itemID 
 
	IF @@ERROR <> 0  
 	BEGIN 
		RAISERROR('AN ERROR HAS OCCURED ON INSERTING ARTICLE PRELOAD', 16, 1) 
		RETURN(99) 
	END 
 
 
--             SELECT @virtualFolder=virtualFolder, @fullLink=fullLink, @pubSectionDesc=pubSectionDesc 
--                        from tblActiveArticles 
--                        where itemId = @itemId   
	 
	UPDATE tblArticlePreload 
	set 
	shortTime = convert(char(20),right(updateDate, 7)), 
	dayOfWeek = convert(varchar(15), datename(weekday,  a.pubDate) ) , 
	virtualFolder = @virtualFolder, 
	pubSectionDesc =  @pubSectionDesc , 
	-- Calculated date fields 
	pubYear = convert(varchar(4), datepart(year, a.pubDate) ) ,  
	pubMonth = right( replicate("0", 2) + convert(varchar(2), datepart(month, a.pubDate)), 2), 
	pubDay = right( replicate("0", 2) + convert(varchar(2), datepart(day, a.pubDate)), 2), 
	dateFolder = convert(varchar(4), datepart(year, a.pubDate) )  +  
	 "/" + right( replicate("0", 2) + convert(varchar(2), datepart(month, a.pubDate)), 2) + 
	  "/" + right( replicate("0", 2) + convert(varchar(2), datepart(day, a.pubDate)), 2), 
	pubDateLong = convert(varchar(10), datename(dw, a.pubDate)) + ", " + 
	             convert(varchar(11), datename(month, a.pubDate) ) + " " + 
	             convert(varchar(2), datepart(day, a.pubDate)) + ", " + 
	             convert(varchar(4), datepart(year, a.pubDate)), 
 
	fullLink = @fullLink, 
articleleadin = articletypeleadin, 
sigImage = ArticleTypeImage, 
sigImageCaption = ArticleTypeName, 
sectionName = s.sectionName, 
sectionDesc=s.sectionDesc, 
sigDir=s.sigDir, 
sectionImage=s.Image, 
sectionType = s.sectionType, 
orderingRank = o.rank, 
hostname = p.hostname, 
 
--articleTypeID = isNull(t.articleTypeID, 0), 
 
listImage = (SELECT isNull(itemName, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='sectionImage'), 
listImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='sectionImage'), 
articleImage = (SELECT isNull(itemName, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='articleImage'), 
articleImageCaption = (SELECT isNull(caption, '') from  tblMultimedia 
	WHERE  tblMultimedia.itemID = @itemID 
	AND tblMultimedia.type='articleImage'), 
 
	--relatedLinksCount = (select count(link) from tblRelatedLinks d where d.itemID = a.itemID), 
	relatedLinksCount = 0, 
	pubDesc = p.pubDesc 
 
from tblArticleOrder o inner join tblArticles a on o.itemID = a.itemID 
	left outer join tblSections s on o.mappingcode = s.mappingcode 
	left outer join tblPublications p on o.pubName = p.pubName  
	left outer join tblArticleTypes t on a.articleTypeID = t.articleTypeID 
    where o.itemID = @itemID AND o.mappingCode = tblArticlePreload.mappingCode  
	and tblArticlePreload.itemid = o.itemid 
 
 	IF @@ERROR <> 0  
 	BEGIN 
		RAISERROR('AN ERROR HAS OCCURED ON UPDATING ARTICLE PRELOAD', 16, 1) 
		RETURN(99) 
 
	END 
END	 
 









CREATE PROCEDURE s_updateModes
@in_mode varchar(100), 
@in_type int, 
@in_delete int

AS
BEGIN

DECLARE @in_action varchar(20)
DECLARE @in_newmodeid int
DECLARE @in_rowexists int

	IF (@in_delete = 0)
		BEGIN
		
			SELECT @in_rowexists = (SELECT count(*) FROM tblPermModes
			WHERE modes = @in_mode 
			AND type = @in_type)

			IF (@in_rowexists = 0)
				SET @in_action = 'insert'

			IF (@@ERROR <> 0)
				BEGIN
					RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMMODES.', 16, 1)
					RETURN(99)
				END
		END

	ELSE
		BEGIN
			SET @in_action = 'delete'
		END


	IF (@in_action = 'delete')
		BEGIN
			DELETE tblPermModes 
			WHERE modes = @in_mode
			AND type = @in_type
			IF (@@ERROR <> 0)
				BEGIN
					RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMMODES.', 16, 1)
					RETURN(99)
				END
		END

	IF (@in_action = 'insert') 
		BEGIN       
			INSERT INTO tblPermModes
			(modes, type)
			VALUES (@in_mode, @in_type)
			IF (@@ERROR <> 0)
				BEGIN
					RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMMODES.', 16, 1)
					RETURN(99)
				END 
		END

	select returnValue = 1

END
GO











CREATE PROCEDURE s_updateSavedSearches
@in_userid int, 
@in_search varchar(1000), 
@in_searchName varchar(500)

AS
BEGIN
	INSERT INTO tblPermsavedSearches
	(userid, search, searchname)
	VALUES (@in_userid, @in_search, @in_searchName)
 
 	IF @@ERROR <> 0 
 		BEGIN
  		RAISERROR ('ERROR: AN ERROR OCCURED DURING INSERTION INTO TBLPERMSAVEDSEARCHES.', 16, 1)
  		RETURN(99)
 	END
 	 SELECT returnValue = 1
END 
GO


